importPackage(java.awt);
importPackage(java.awt.geom);


include(Resources.id("mtrsteamloco:scripts/display_helper.js"));

let slotCfg = {
  "version": 1,
  "texSize": [1568, 128],
  "slots": [
    {
      "name": "front",    
      "texArea": [0, 0, 784, 64],
      "pos": [
        [[0.4251, 2.4488, 8.3976],  [0.4251, 2.3779, 8.3976], [-0.443, 2.3779, 8.3976], [-0.443, 2.4488, 8.3976]]
      ],
      "offsets": [[0, 0, 0]]
    },
    {
      "name": "back",    
      "texArea": [0, 0, 784, 64],
      "pos": [
        [[-0.4251, 2.4488, -10.148],  [-0.4251, 2.3779, -10.148], [0.443, 2.3779, -10.148], [0.443, 2.4488, -10.148]]
      ],
      "offsets": [[0, 0, 0]]
    }
  ]
};

let slotMiddleCfg = {
  "version": 1,
  "texSize": [1568, 128],
  "slots": [
    {
      "name": "front",    
      "texArea": [0, 0, 784, 64],
      "pos": [
        [[0.4251, 2.4488, 10.148],  [0.4251, 2.3779, 10.148], [-0.443, 2.3779, 10.148], [-0.443, 2.4488, 10.148]]
      ],
      "offsets": [[0, 0, 0]]
    },
    {
      "name": "back",    
      "texArea": [0, 0, 784, 64],
      "pos": [
        [[-0.4251, 2.4488, -10.148],  [-0.4251, 2.3779, -10.148], [0.443, 2.3779, -10.148], [0.443, 2.4488, -10.148]]
      ],
      "offsets": [[0, 0, 0]]
    }
  ]
};

let slotReversedCfg = {
  "version": 1,
  "texSize": [1568, 128],
  "slots": [
    {
      "name": "front",    
      "texArea": [0, 0, 784, 64],
      "pos": [
        [[-0.4251, 2.4488, -8.3976],  [-0.4251, 2.3779, -8.3976], [0.443, 2.3779, -8.3976], [0.443, 2.4488, -8.3976]]
      ],
      "offsets": [[0, 0, 0]]
    },
    {
      "name": "back",    
      "texArea": [0, 0, 784, 64],
      "pos": [
        [[0.4251, 2.4488, 10.148],  [0.4251, 2.3779, 10.148], [-0.443, 2.3779, 10.148], [-0.443, 2.4488, 10.148]]
      ],
      "offsets": [[0, 0, 0]]
    }
  ]
};


var serifFont = Resources.readFont(Resources.idRelative("mtr:metropackint/fonts/rusich-led.ttf"));
const maxTickDispConst = 80;
var dhBase = new DisplayHelper(slotCfg);

function displCreate(ctx, state, train) {
	state.pisRateLimit = new RateLimit(0.07);
  state.dh = dhBase.create();
  state.displTick = 0;

  state.displString = "";
  // state.displString2 = "";
  state.displTickMax = 0;
}

function displDispose(ctx, state, train) {
	state.dh.close();
}

function displRender(ctx, state, train, matrices) {
	if (state.pisRateLimit.shouldUpdate() && train.shouldRenderDetail()) {
    upadteTick(state, train); // системат тиков, нужна для оптимизации
    let g = null;

    g = state.dh.graphics();
    let fontMetrics;
    fontMetrics = g.getFontMetrics(); 
    
    let ticker = state.displString;
    let end = state.displString2;
    let ticker_width = Math.round(fontMetrics.stringWidth(ticker));
    let end_width = Math.round(fontMetrics.stringWidth(end));
    let route_num = state.routeNum;
    
    state.displTickMax = Math.floor(maxTickDispConst * ticker_width / 700);

    if ((state.displTickMax == 0) || (state.displTick % Math.floor(state.displTickMax / 5) == 0)) { // каждый maxTickDisp-й тик обновляется переменная. Нужно это для оптимизации, дабы каждый тик не вызывать функции
      
      if (train.getThisRoutePlatforms().size() != 0) {
        state.displString = calcDisplString(train);
        state.displString2 = getEndStation(train);
        state.routeNum = getRouteNum(train);
      } else {
        state.displString = "Tram is going to the depot. Not in service. Трамвай следует в депо. Посадки нет.   ";
        state.displString2 = "Посадки нет";
        state.routeNum = "--";
      }
    }

    drawTickerFront(g, state.displString2, state, end_width, route_num);
    drawTicker(g, state, ticker, ticker_width);
    state.dh.upload();
  }

  for (let i = 0; i < train.trainCars(); i++) {
    ctx.drawCarModel(state.dh.model, i, null);
  }
}

function upadteTick(state, train) {
  state.displTick++;
  if (state.displTickMax < state.displTick) state.displTick = 0;
} 

function getEndStation(train) {
  let stationList = train.getThisRoutePlatforms();
  let ret = "";
  ret = stationList[0].destinationName;
  return ret;
}

function calcDisplString(train) {
  let stationList = train.getThisRoutePlatforms();
  let ticker = "";

  for (let i = 0; i < stationList.size(); i++) {
    ticker += stationList[i].station.name;
    if (i != stationList.size() - 1) {
      ticker += " - ";
    } else {
      ticker += ".      ";
    }
  }
  return ticker;
}

function drawTicker(g, state, t_string, t_width) {
  g.setColor(Color.BLACK);
  g.fillRect(0, 0, 784, 64);
  g.setFont(serifFont.deriveFont(0, 90));
  g.setColor(Color.GREEN);

  let tick = state.displTick;

  let half = Math.round(state.displTickMax / 2);
  let offset = 784 + Math.max(10 + t_width - 784, 0); // 784 - длина строки в пикселях

  let x1 = 0;
  let x2 = 0;
  if (tick < half) {
    x1 = tick / half * (-offset);
    x2 = offset * (1 - tick / half);
  } else {
    x1 = offset * (2 - (tick / half));
    x2 = (tick / half - 1) * (-offset);
  }

  x1 = Math.round(x1);
  x2 = Math.round(x2);
  // print (t_string +"="+t_width)
  g.drawString(t_string, x1, 58);
  g.drawString(t_string, x2, 58);

  // state.dh.upload();
}

function drawTickerFront(g, string, state, t_width, route_num) {
  string += "";
  route_num += "";
  let size = Math.min(70 * 3 / route_num.length, 80);
  size = Math.min(90, size);

  let tick = state.displTick * 4 % state.displTickMax;
  let half = Math.round(state.displTickMax / 2);
  let offset = 400 + Math.max(50 + t_width - 400, 0); 
  let x1 = 0;
  let x2 = 0;
  let x_route = -9*route_num.length + 34
  if (tick < half) {
    x1 = tick / half * (-offset);
    x2 = offset * (1 - tick / half);
  } else {
    x1 = offset * (2 - (tick / half));
    x2 = (tick / half - 1) * (-offset);
  }
  g.setColor(Color.BLACK);
  g.fillRect(0, 64, 784, 128);
  g.setFont(serifFont.deriveFont(0, 70));
  g.setColor(Color.GREEN);

  g.drawString(string, x1, 115);
  g.drawString(string, x2, 115);

  if (route_num.length == 0) return;
  g.setColor(Color.BLACK);
  g.fillRect(0, 64, 115, 128);
  g.setColor(Color.GREEN);
  g.setFont(serifFont.deriveFont(0, size));
  g.drawString(route_num, x_route, 120);
  // state.dh.upload();
}

function clamp(num, min, max) {
  return Math.min(Math.max(num, min), max);
} 

function getRouteNum(train) {
  
  let stationList = train.getThisRoutePlatforms();
  let ret = stationList[0].route.lightRailRouteNumber + "";
  return ret;
}