importPackage(java.awt);
importPackage(java.awt.geom);
include(Resources.id('mtrsteamloco:scripts/display_helper.js'));

let slotCfg = {									//ЭМУ ГОЛОВНОЙ (БЕЛЫЕ ОГНИ) ВАГОН
    version: 1,
    texSize: [1024, 128],
    slots: [
        {
            name: 'head',
            texArea: [0, 0, 1024, 128],
            pos: [
                [
                    [-0.665157, 2.49511, 10.87],		//ЭМУ Левый Верхний Угол XYZ
                    [-0.665157, 2.31747, 10.92],		//ЭМУ Левый Нижний Угол XYZ
                    [0.665157, 2.31747, 10.92],			//ЭМУ Правый Нижний Угол XYZ
                    [0.665157, 2.49511, 10.87]		//ЭМУ Правый Верхний Угол XYZ
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let slotReversedCfg = {							//ЭМУ ХВОСТОВОЙ (КРАСНЫЕ ОГНИ) ВАГОН
    version: 1,
    texSize: [1024, 128],
    slots: [
        {
            name: 'head-reversed',
            texArea: [0, 0, 1024, 128],
            pos: [
                [
                    [0.665157, 2.49511, -10.87],		//ЭМУ Левый Верхний Угол XYZ
                    [0.665157, 2.31747, -10.92],		//ЭМУ Левый Нижний Угол XYZ
                    [-0.665157, 2.31747, -10.92],			//ЭМУ Правый Нижний Угол XYZ
                    [-0.665157, 2.49511, -10.87]	//ЭМУ Правый Верхний Угол XYZ
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let dhBase = new DisplayHelper(slotCfg);
let dhReversedBase = new DisplayHelper(slotReversedCfg);

function create(ctx, state, train) {
    state.pisRateLimit = new RateLimit(0.05);
    state.dh = dhBase.create();
    state.dhReversed = dhReversedBase.create();
    state.randomID = Math.floor(1 + (Math.random() * 29));							//Генерация рандомного номера маршрута (От 1 до 30)
	if (state.randomID >9) return (state.routeID = "0"+state.randomID+"|");			//Добавление нуля перед сгенерированным номером на ЭМУ
	else return (state.routeID = "00"+state.randomID+"|");								//Добавление двух нулей в случае если число меньше 10
}

function dispose(ctx, state, train) {
    state.dh.close();
    state.dhReversed.close();
}

var EMUFont = Resources.readFont(
    Resources.idRelative('mtr:metropackint/fonts/moscowsansregular.ttf')
);																				//Тип шрифта

function render(ctx, state, train) {
    if (state.pisRateLimit.shouldUpdate()) {
        let g;

        let EMUText = getDestinationStation(train);

        [
            { dh: state.dh, graphicsName: 'head' },
            { dh: state.dhReversed, graphicsName: 'head-reversed' },
        ].forEach((element) => {
            let dh = element.dh;
            g = dh.graphicsFor(element.graphicsName);
            g.setColor(Color.BLACK);									//Цвет заднего фона
            g.fillRect(0, 0, 1024, 128);								//Площадь заливки заднего фона
            g.setColor(Color.WHITE); 									//Цвет текста
            g.setFont(EMUFont.deriveFont(Font.PLAIN, 114)); 			//Размер шрифта
            g.drawString(state.routeID, 12, 102);						//Вывод номера маршрута
            let fontMetrics = g.getFontMetrics();
            let routeWidth = fontMetrics.stringWidth(state.routeID);
            let textWidth = fontMetrics.stringWidth(EMUText);
            g.drawString(												//Вывод названия конечной станции
                EMUText,
                routeWidth + (1024 - routeWidth - textWidth) / 2,
                102
            );
            dh.upload();
        });
    }

    ctx.drawCarModel(state.dh.model, 0, null);
    ctx.drawCarModel(state.dhReversed.model, train.trainCars() - 1, null);
}

function getDestinationStation(train) {
    let stationList = train.getThisRoutePlatforms();
    let lastPlatform = stationList[stationList.size() - 1];
    if (lastPlatform === undefined) return 'ROUTE';				//Выводимая на ЭМУ надпись в отсутствии указанной конечной станции
    return lastPlatform.destinationName.split('\\|')[0];
}
