importPackage(java.awt);
importPackage(java.awt.geom);
include(Resources.id('mtrsteamloco:scripts/display_helper.js'));

let slotCfg = {									//ЭМУ ГОЛОВНОЙ (БЕЛЫЕ ОГНИ) ВАГОН
    version: 1,
    texSize: [1024, 128],
    slots: [
        {
            name: 'head',
            texArea: [0, 0, 1024, 128],
            pos: [
                [
                    [-0.7281, 2.2455 , 10.152],
                    [-0.7281, 2.01694, 10.152],
                    [0.7281, 2.01694, 10.152],
                    [0.7281, 2.2455, 10.152],		//ЭМУ Правый Верхний Угол XYZ
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let slotReversedCfg = {							//ЭМУ ХВОСТОВОЙ (КРАСНЫЕ ОГНИ) ВАГОН
    version: 1,
    texSize: [1024, 128],
    slots: [
        {
            name: 'head-reversed',
            texArea: [0, 0, 1024, 128],
            pos: [
                [
                    [0.7281, 2.2455 , -10.152],
                    [0.7281, 2.01694, -10.152],
                    [-0.7281, 2.01694, -10.152],
                    [-0.7281, 2.2455, -10.152],		//ЭМУ Правый Верхний Угол XYZ
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let dhBase = new DisplayHelper(slotCfg);
let dhReversedBase = new DisplayHelper(slotReversedCfg);

function create(ctx, state, train) {
    state.pisRateLimit = new RateLimit(0.05);
    state.dh = dhBase.create();
    state.dhReversed = dhReversedBase.create();
    state.randomID = "";							//Генерация рандомного номера маршрута (От 1 до 30)
	if (state.randomID >9) return (state.routeID = "0"+state.randomID);			    //Добавление нуля перед сгенерированным номером на ЭМУ
	else return (state.routeID = "00"+state.randomID);								//Добавление двух нулей в случае если число меньше 10
}

function dispose(ctx, state, train) {
    state.dh.close();
    state.dhReversed.close();
}

var EMUFont = Resources.readFont(
    Resources.idRelative('mtr:metropackint/fonts/rusich-led.ttf')
);

function render(ctx, state, train) {
    if (state.pisRateLimit.shouldUpdate()) {
        let g;

        let EMUText = getDestinationStation(train);

        [
            { dh: state.dh, graphicsName: 'head' },
            { dh: state.dhReversed, graphicsName: 'head-reversed' },
        ].forEach((element) => {
            let dh = element.dh;
            g = dh.graphicsFor(element.graphicsName);
            g.setColor(Color.BLACK);
            g.fillRect(0, 0, 1024, 128);
            g.setColor(Color.RED);
            g.setFont(EMUFont.deriveFont(Font.PLAIN, 62));
            //g.drawString(state.routeID, 10, 98);
            let fontMetrics = g.getFontMetrics();
            let routeWidth = fontMetrics.stringWidth(state.routeID);
            let textWidth = fontMetrics.stringWidth(EMUText);
            g.drawString(
                EMUText,
                routeWidth + (1024 - routeWidth - textWidth) / 3,
                70
            );
            dh.upload();
        });
    }

    ctx.drawCarModel(state.dh.model, 0, null);
    ctx.drawCarModel(state.dhReversed.model, train.trainCars() - 1, null);
}

function getDestinationStation(train) {
    let stationList = train.getThisRoutePlatforms();
    let lastPlatform = stationList[stationList.size() - 1];
    if (lastPlatform === undefined) return 'ПОСАДКИ НЕТ';
    return lastPlatform.destinationName.split('\\|')[0].toUpperCase();
}
