importPackage(java.awt);
importPackage(java.awt.geom);
include(Resources.id('mtrsteamloco:scripts/display_helper.js'));

let slotCfg = {									//ЭМУ ГОЛОВНОЙ (БЕЛЫЕ ОГНИ) ВАГОН
    version: 1,
    texSize: [768, 128],
    slots: [
        {
            name: 'head',
            texArea: [0, 0, 768, 128],
            pos: [
                [
                    [-0.5997, 1.8428 , 10.1584],
                    [-0.5997, 1.6579, 10.1584],
                    [0.6134, 1.6579, 10.1584],
                    [0.6134, 1.8428, 10.1584],		//ЭМУ Правый Верхний Угол XYZ
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let slotReversedCfg = {							//ЭМУ ХВОСТОВОЙ (КРАСНЫЕ ОГНИ) ВАГОН
    version: 1,
    texSize: [768, 128],
    slots: [
        {
            name: 'head-reversed',
            texArea: [0, 0, 768, 128],
            pos: [
                [
                    [0.5997, 1.8428, -10.1584],		//ЭМУ Левый Верхний Угол XYZ
                    [0.5997, 1.6579, -10.1584],  		//ЭМУ Левый Нижний Угол XYZ
                    [-0.6134, 1.6579, -10.1584], 		//ЭМУ Правый Нижний Угол XYZ
                    [-0.6134, 1.8428, -10.1584],		//ЭМУ Правый Верхний Угол XYZ
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let dhBase = new DisplayHelper(slotCfg);
let dhReversedBase = new DisplayHelper(slotReversedCfg);

function create(ctx, state, train) {
    state.pisRateLimit = new RateLimit(0.05);
    state.dh = dhBase.create();
    state.dhReversed = dhReversedBase.create();
    //state.routeID = Math.floor(Math.random() * 100);
    state.routeID = Math.abs(train.id() % 100);
}

function dispose(ctx, state, train) {
    state.dh.close();
    state.dhReversed.close();
}

var EMUFont = Resources.readFont(
    Resources.idRelative('mtr:metropackint/fonts/81-717-nizhny-novgorod.ttf')
);																				//Тип шрифта

function render(ctx, state, train) {
    if (state.pisRateLimit.shouldUpdate()) {
        let g;

        let EMUText = getDestinationStation(train);

        [
            { dh: state.dh, graphicsName: 'head' },
            { dh: state.dhReversed, graphicsName: 'head-reversed' },
        ].forEach((element) => {
            let dh = element.dh;
            g = dh.graphicsFor(element.graphicsName);
            g.setColor(Color.BLACK);									//Цвет заднего фона
            g.fillRect(0, 0, 768, 128);								    //Площадь заливки заднего фона
            g.setColor(Color.GREEN); 									//Цвет текста
            g.setFont(EMUFont.deriveFont(Font.PLAIN, 70)); 			//Размер шрифта
            g.drawString(state.routeID, 18, 102);						//Вывод номера маршрута
            let fontMetrics = g.getFontMetrics();
            let routeWidth = fontMetrics.stringWidth(state.routeID);
            let textWidth = fontMetrics.stringWidth(EMUText);
            g.drawString(												//Вывод названия конечной станции
                EMUText,
                routeWidth + (768 - routeWidth - textWidth) / 2,
                98
            );
            dh.upload();
        });
    }

    ctx.drawCarModel(state.dh.model, 0, null);
    ctx.drawCarModel(state.dhReversed.model, train.trainCars() - 1, null);
}

function getDestinationStation(train) {
    let stationList = train.getThisRoutePlatforms();
    let lastPlatform = stationList[stationList.size() - 1];
    if (lastPlatform === undefined) return 'ОБКАТКА';				//Выводимая на ЭМУ надпись в отсутствии указанной конечной станции
    return lastPlatform.destinationName.split('\\|')[0].toUpperCase();
}
