importPackage(java.awt);
importPackage(java.awt.geom);
include(Resources.id('mtrsteamloco:scripts/display_helper.js'));

let slotCfgl = {
    version: 1,
    texSize: [347, 256],
    slots: [
        {
            name: 'head-l',
            texArea: [0, 0, 347, 256],
            pos: [
                [
                    [0.8752, 0.9282, 10.13],
                    [0.8752, 0.7779, 10.13],
                    [0.9843, 0.7779, 10.11],
                    [0.9843, 0.9282, 10.11],
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let slotReversedCfgl = {
    version: 1,
    texSize: [347, 256],
    slots: [
        {
            name: 'head-reversed-l',
            texArea: [0, 0, 347, 256],
            pos: [
                [
                    [-0.8752, 0.9282, -10.13],
                    [-0.8752, 0.7779, -10.13],
                    [-0.9843, 0.7779, -10.11],
                    [-0.9843, 0.9282, -10.11],
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let slotCfgr = {
    version: 1,
    texSize: [347, 256],
    slots: [
        {
            name: 'head-r',
            texArea: [0, 0, 347, 256],
            pos: [
                [
                    [1.015, 0.9282, 10.1],
                    [1.015, 0.7779, 10.1],
                    [1.124, 0.7779, 10.08],
                    [1.124, 0.9282, 10.08],
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let slotReversedCfgr = {
    version: 1,
    texSize: [347, 256],
    slots: [
        {
            name: 'head-reversed-r',
            texArea: [0, 0, 347, 256],
            pos: [
                [
                    [-1.015, 0.9282, -10.1],
                    [-1.015, 0.7779, -10.1],
                    [-1.124, 0.7779, -10.08],
                    [-1.124, 0.9282, -10.08],
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let dhBasel = new DisplayHelper(slotCfgl);
let dhReversedBasel = new DisplayHelper(slotReversedCfgl);
let dhBaser = new DisplayHelper(slotCfgr);
let dhReversedBaser = new DisplayHelper(slotReversedCfgr);

function create(ctx, state, train) {
    state.pisRateLimit = new RateLimit(0.05);
    state.dhl = dhBasel.create();
    state.dhr = dhBaser.create();
    state.dhReversedl = dhReversedBasel.create();
    state.dhReversedr = dhReversedBaser.create();
    //state.routeID = Math.floor(Math.random() * 100);
    state.routeIDl = Math.abs(train.id() % 10);
    state.routeIDr = Math.abs(train.id() % 10);
}

function dispose(ctx, state, train) {
    state.dhl.close();
    state.dhr.close();
    state.dhReversedl.close();
    state.dhReversedr.close();
}

var EMUFont = Resources.readFont(
    Resources.idRelative('mtr:metropackint/fonts/81-717-novosibirsk.ttf')
);

function render(ctx, state, train) {
    if (state.pisRateLimit.shouldUpdate()) {
        let g;

        [
            { dh: state.dhl, graphicsName: 'head-l' },
            { dh: state.dhReversedl, graphicsName: 'head-reversed-l' },
        ].forEach((element) => {
            let dh = element.dh;
            g = dh.graphicsFor(element.graphicsName);
            g.setColor(Color.RED);
            g.setFont(EMUFont.deriveFont(Font.PLAIN, 130));
            g.drawString(state.routeID, 0, 256);
            dhl.upload();
        }),

        [
            { dh: state.dhr, graphicsName: 'head-r' },
            { dh: state.dhReversedr, graphicsName: 'head-reversed-r' },
        ].forEach((element) => {
            let dh = element.dh;
            g = dh.graphicsFor(element.graphicsName);
            g.setColor(Color.RED);
            g.setFont(EMUFont.deriveFont(Font.PLAIN, 130));
            g.drawString(state.routeID2, 0, 256);
            dh.upload();
        });
    }

    ctx.drawCarModel(state.dh.model, 0, null);
    ctx.drawCarModel(state.dh2.model, 0, null);
    ctx.drawCarModel(state.dhReversed.model, train.trainCars() - 1, null);
    ctx.drawCarModel(state.dhReversed2.model, train.trainCars() - 1, null);
}
