importPackage(java.awt);
importPackage(java.awt.geom);
include(Resources.id('mtrsteamloco:scripts/display_helper.js'));

let slotCfg = {
    version: 1,
    texSize: [288, 183],
    slots: [
        {
            name: 'head',
            texArea: [0, 0, 288, 183],
            pos: [
                [
                    [0.8752, 0.9282, 10.13],
                    [0.8752, 0.7779, 10.13],
                    [1.124, 0.7779, 10.08],
                    [1.124, 0.9282, 10.08],
                ],
            ],
            offsets: [[0.01, 0.01, 0]],
        },
    ],
};

let slotReversedCfg = {
    version: 1,
    texSize: [288, 183],
    slots: [
        {
            name: 'head-reversed',
            texArea: [0, 0, 288, 183],
            pos: [
                [
                    [-0.8752, 0.9282, -10.13],
                    [-0.8752, 0.7779, -10.13],
                    [-1.124, 0.7779, -10.08],
                    [-1.124, 0.9282, -10.08],
                ],
            ],
            offsets: [[0.01, 0.01, 0]],
        },
    ],
};

let dhBase = new DisplayHelper(slotCfg);
let dhReversedBase = new DisplayHelper(slotReversedCfg);

function create(ctx, state, train) {
    state.pisRateLimit = new RateLimit(0.05);
    state.dh = dhBase.create();
    state.dhReversed = dhReversedBase.create();
    //state.routeID = Math.floor(Math.random() * 100);
    state.randomID = Math.abs(train.id() % 10);
    state.randomID2 = Math.abs(train.id() % 10);
}

function dispose(ctx, state, train) {
    state.dh.close();
    state.dhReversed.close();
}

var EMUFont = Resources.readFont(
    Resources.idRelative('mtr:metropackint/fonts/81-717-novosibirsk.ttf')
);

function render(ctx, state, train) {
    if (state.pisRateLimit.shouldUpdate()) {
        let g;

        [
            { dh: state.dh, graphicsName: 'head' },
            { dh: state.dhReversed, graphicsName: 'head-reversed' },
        ].forEach((element) => {
            let dh = element.dh;
            state.routeID = state.randomID + " " + state.randomID2;
            g = dh.graphicsFor(element.graphicsName);
            g.setColor(Color.RED);
            g.setFont(EMUFont.deriveFont(Font.PLAIN, 156));
            g.drawString(state.routeID, 0, 183);
            dh.upload();
        });
    }

    ctx.drawCarModel(state.dh.model, 0, null);
    ctx.drawCarModel(state.dhReversed.model, train.trainCars() - 1, null);
}
