importPackage(java.awt);
importPackage(java.awt.geom);
include(Resources.id('mtrsteamloco:scripts/display_helper.js'));

let slotCfg = {									//ЭМУ ГОЛОВНОЙ (БЕЛЫЕ ОГНИ) ВАГОН
    version: 1,
    texSize: [768, 128],
    slots: [
        {
            name: 'head',
            texArea: [0, 0, 768, 128],
            pos: [
                [
                    [-0.284438, 2.174 , 10.82],
                    [-0.284438, 2.01694, 10.82],
                    [1.08512, 2.01694, 10.82],
                    [1.08512, 2.174, 10.82],		//ЭМУ Правый Верхний Угол XYZ
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let slotReversedCfg = {							//ЭМУ ХВОСТОВОЙ (КРАСНЫЕ ОГНИ) ВАГОН
    version: 1,
    texSize: [768, 128],
    slots: [
        {
            name: 'head-reversed',
            texArea: [0, 0, 768, 128],
            pos: [
                [
                    [0.304, 2.185, -10.844],		//ЭМУ Левый Верхний Угол XYZ
                    [0.304, 2.015, -10.844],  		//ЭМУ Левый Нижний Угол XYZ
                    [-1.124, 2.015, -10.844], 		//ЭМУ Правый Нижний Угол XYZ
                    [-1.124, 2.185, -10.844],		//ЭМУ Правый Верхний Угол XYZ
                ],
            ],
            offsets: [[0, 0, 0]],
        },
    ],
};

let dhBase = new DisplayHelper(slotCfg);
let dhReversedBase = new DisplayHelper(slotReversedCfg);

function create(ctx, state, train) {
    state.pisRateLimit = new RateLimit(0.05);
    state.dh = dhBase.create();
    state.dhReversed = dhReversedBase.create();
    state.randomID = Math.floor(1 + (Math.random() * 29));							//Генерация рандомного номера маршрута (От 1 до 30)
	if (state.randomID >9) return (state.routeID = "0"+state.randomID);			    //Добавление нуля перед сгенерированным номером на ЭМУ
	else return (state.routeID = "00"+state.randomID);								//Добавление двух нулей в случае если число меньше 10
}

function dispose(ctx, state, train) {
    state.dh.close();
    state.dhReversed.close();
}

var EMUFont = Resources.readFont(
    Resources.idRelative('mtr:metropackint/fonts/760_emu.ttf')
);																				//Тип шрифта

function render(ctx, state, train) {
    if (state.pisRateLimit.shouldUpdate()) {
        let g;

        let EMUText = getDestinationStation(train);

        [
            { dh: state.dh, graphicsName: 'head' },
            { dh: state.dhReversed, graphicsName: 'head-reversed' },
        ].forEach((element) => {
            let dh = element.dh;
            g = dh.graphicsFor(element.graphicsName);
            g.setColor(Color.BLACK);									//Цвет заднего фона
            g.fillRect(0, 0, 768, 128);								    //Площадь заливки заднего фона
            g.setColor(Color.GREEN); 									//Цвет текста
            g.setFont(EMUFont.deriveFont(Font.PLAIN, 120)); 			//Размер шрифта
            g.drawString(state.routeID, 18, 102);						//Вывод номера маршрута
            let fontMetrics = g.getFontMetrics();
            let routeWidth = fontMetrics.stringWidth(state.routeID);
            let textWidth = fontMetrics.stringWidth(EMUText);
            g.drawString(												//Вывод названия конечной станции
                EMUText,
                routeWidth + (768 - routeWidth - textWidth) / 2,
                98
            );
            dh.upload();
        });
    }

    ctx.drawCarModel(state.dh.model, 0, null);
    ctx.drawCarModel(state.dhReversed.model, train.trainCars() - 1, null);
}

function getDestinationStation(train) {
    let stationList = train.getThisRoutePlatforms();
    let lastPlatform = stationList[stationList.size() - 1];
    if (lastPlatform === undefined) return 'обкатка';				//Выводимая на ЭМУ надпись в отсутствии указанной конечной станции
    return lastPlatform.destinationName.split('\\|')[0];
}
