var pathToNewTexture = "mtr:metropackint/tash717mmz222/81-717.5.png"
var pathToNewTexture2 = "mtr:metropackint/tash717mmz222/81-717.5_int.png"

var rawModels = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:metropackint/717base.obj"), null);
var rawModels2 = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtr:metropackint/714base.obj"), null);

var modelsH = uploadPartedModels(rawModels)
var modelsM = uploadPartedModels(rawModels2)

repaint(modelsH)
repaint2(modelsM)


function create(ctx, state, train) {

}

function dispose(ctx, state, train) {

}

function render(ctx, state, train) {
	let matrices = new Matrices();
	renderHead(ctx, state, train, 0, matrices) // Голова
	if (train.trainCars() > 1) {
		for (var i = 1; i < train.trainCars() - 1; i++) {
			renderMiddle(ctx, state, train, i, matrices); // Средняя часть
		}
		renderTail(ctx, state, train, train.trainCars() - 1, matrices); // хвост
	}

}

function renderHead(ctx, state, train, i, matrices) {
	let m = modelsH;
	let doorValue = Math.min(train.doorValue() * 2, 1);
	let isLSDActive = doorValue > 0;
	let isLPTActive = train.speed() == 0;

	let isLeftOpen = train.doorLeftOpen[i];
	let isRightOpened = train.doorRightOpen[i];

	const doorLength = 0.63

	let leftCoef = isLeftOpen ? smoothCubic(doorValue) * doorLength : 0.0;
	let rightCoef = isRightOpened ? smoothCubic(doorValue) * doorLength : 0.0;

	// body
	ctx.drawCarModel(m["EXT"], i, matrices);
	ctx.drawCarModel(m["EXT1"], i, matrices);
	ctx.drawCarModel(m["3GOFRI"], i, matrices);
	ctx.drawCarModel(m["VODOSTOK_MVM"], i, matrices);
	ctx.drawCarModel(m["TELEGI1"], i, matrices);

	ctx.drawCarModel(m["INT"], i, matrices);
	ctx.drawCarModel(m["LUKI3"], i, matrices);
	ctx.drawCarModel(m["INTLAMPS2"], i, matrices);
	ctx.drawCarModel(m["SIDUHI2"], i, matrices);

	ctx.drawCarModel(m["MVM222"], i, matrices);

	// lights
	if (train.isReversed()) {
		ctx.drawCarModel(m["BUF"], i, matrices);
	} else {
		ctx.drawCarModel(m["FARY222"], i, matrices);
	}

	// signals
	if (isLSDActive) ctx.drawCarModel(m["lsd"], i, matrices); 
	if (isLPTActive) ctx.drawCarModel(m["lpt"], i, matrices); 

	// doors
	matrices.pushPose();
	matrices.translate(0,0, rightCoef)
	ctx.drawCarModel(m["D_RF_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_RF_INT"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0,0, -rightCoef)
	ctx.drawCarModel(m["D_RB_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_RB_INT"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0,0, leftCoef)
	ctx.drawCarModel(m["D_LF_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_LF_INT"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0,0, -leftCoef)
	ctx.drawCarModel(m["D_LB_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_LB_INT"], i, matrices);
	matrices.popPose();
}

function renderMiddle(ctx, state, train, i, matrices) {
	let m = modelsM;
	let doorValue = Math.min(train.doorValue() * 2, 1);;
	let isLSDActive = doorValue > 0;
	let isLPTActive = train.speed() == 0;

	let isLeftOpen = train.doorLeftOpen[i];
	let isRightOpened = train.doorRightOpen[i];

	const doorLength = 0.63

	let leftCoef = isLeftOpen ? smoothCubic(doorValue) * doorLength : 0.0;
	let rightCoef = isRightOpened ? smoothCubic(doorValue) * doorLength : 0.0;

	

	// body
	ctx.drawCarModel(m["EXT"], i, matrices);
	ctx.drawCarModel(m["EXT1"], i, matrices);
	ctx.drawCarModel(m["3GOFRI"], i, matrices);
	ctx.drawCarModel(m["VODOSTOK_MVM"], i, matrices);
	ctx.drawCarModel(m["TELEGI1"], i, matrices);

	ctx.drawCarModel(m["INT"], i, matrices);
	ctx.drawCarModel(m["LUKI3"], i, matrices);
	ctx.drawCarModel(m["INTLAMPS2"], i, matrices);
	ctx.drawCarModel(m["SIDUHI2"], i, matrices);

	// signals
	if (isLSDActive) ctx.drawCarModel(m["lsd"], i, matrices); 
	if (isLPTActive) ctx.drawCarModel(m["lpt"], i, matrices); 

	// doors
	matrices.pushPose();
	matrices.translate(0,0, rightCoef)
	ctx.drawCarModel(m["D_RF_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_RF_INT"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0,0, -rightCoef)
	ctx.drawCarModel(m["D_RB_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_RB_INT"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0,0, leftCoef)
	ctx.drawCarModel(m["D_LF_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_LF_INT"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0,0, -leftCoef)
	ctx.drawCarModel(m["D_LB_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_LB_INT"], i, matrices);
	matrices.popPose();
}

function renderTail(ctx, state, train, i, matrices) {
	let m = modelsH;
	let doorValue = Math.min(train.doorValue() * 2, 1);
	let isLSDActive = doorValue > 0;
	let isLPTActive = train.speed() == 0;

	let isLeftOpen = train.doorLeftOpen[i];
	let isRightOpened = train.doorRightOpen[i];

	const doorLength = 0.63
	let leftCoef = isRightOpened ? smoothCubic(doorValue) * doorLength : 0.0; // swaped because model turned 
	let rightCoef = isLeftOpen ? smoothCubic(doorValue) * doorLength : 0.0;

	

	matrices.pushPose();

	matrices.rotateY(3.141592);

	// body
	ctx.drawCarModel(m["EXT"], i, matrices);
	ctx.drawCarModel(m["EXT1"], i, matrices);
	ctx.drawCarModel(m["3GOFRI"], i, matrices);
	ctx.drawCarModel(m["VODOSTOK_MVM"], i, matrices);
	ctx.drawCarModel(m["TELEGI1"], i, matrices);

	ctx.drawCarModel(m["INT"], i, matrices);
	ctx.drawCarModel(m["LUKI3"], i, matrices);
	ctx.drawCarModel(m["INTLAMPS2"], i, matrices);
	ctx.drawCarModel(m["SIDUHI2"], i, matrices);

	ctx.drawCarModel(m["MVM222"], i, matrices);

	// lights
	if (!train.isReversed()) {
		ctx.drawCarModel(m["BUF"], i, matrices);
	} else {
		ctx.drawCarModel(m["FARY222"], i, matrices);
	}

	// signals
	if (isLSDActive) ctx.drawCarModel(m["lsd"], i, matrices); 
	if (isLPTActive) ctx.drawCarModel(m["lpt"], i, matrices); 

	// doors
	matrices.pushPose();
	matrices.translate(0,0, rightCoef)
	ctx.drawCarModel(m["D_RF_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_RF_INT"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0,0, -rightCoef)
	ctx.drawCarModel(m["D_RB_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_RB_INT"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0,0, leftCoef)
	ctx.drawCarModel(m["D_LF_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_LF_INT"], i, matrices);
	matrices.popPose();

	matrices.pushPose();
	matrices.translate(0,0, -leftCoef)
	ctx.drawCarModel(m["D_LB_EXT1"], i, matrices);
	ctx.drawCarModel(m["D_LB_INT"], i, matrices);
	matrices.popPose();

	matrices.popPose();
}



function repaint(models) {
	models["EXT"] = models["EXT"].copyForMaterialChanges();
	models["3GOFRI"] = models["3GOFRI"].copyForMaterialChanges();
	models["VODOSTOK_MVM"] = models["VODOSTOK_MVM"].copyForMaterialChanges();
	models["MVM222"] = models["MVM222"].copyForMaterialChanges();

	models["D_RF_EXT1"] = models["D_RF_EXT1"].copyForMaterialChanges();
	models["D_RB_EXT1"] = models["D_RB_EXT1"].copyForMaterialChanges();
	models["D_LF_EXT1"] = models["D_LF_EXT1"].copyForMaterialChanges();
	models["D_LB_EXT1"] = models["D_LB_EXT1"].copyForMaterialChanges();

	models["EXT"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["3GOFRI"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["VODOSTOK_MVM"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["MVM222"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));

	models["D_RF_EXT1"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["D_RB_EXT1"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["D_LF_EXT1"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["D_LB_EXT1"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));

	models["D_RF_INT"] = models["D_RF_INT"].copyForMaterialChanges();
	models["D_RB_INT"] = models["D_RB_INT"].copyForMaterialChanges();
	models["D_LF_INT"] = models["D_LF_INT"].copyForMaterialChanges();
	models["D_LB_INT"] = models["D_LB_INT"].copyForMaterialChanges();

	models["INT"] = models["INT"].copyForMaterialChanges();
	models["INTLAMPS2"] = models["INTLAMPS2"].copyForMaterialChanges();
	models["SIDUHI2"] = models["SIDUHI2"].copyForMaterialChanges();

	models["INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["INTLAMPS2"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["SIDUHI2"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));

	models["D_RF_INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["D_RB_INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["D_LF_INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["D_LB_INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
}

function repaint2(models) {
	models["EXT"] = models["EXT"].copyForMaterialChanges();
	models["3GOFRI"] = models["3GOFRI"].copyForMaterialChanges();
	models["VODOSTOK_MVM"] = models["VODOSTOK_MVM"].copyForMaterialChanges();

	models["D_RF_EXT1"] = models["D_RF_EXT1"].copyForMaterialChanges();
	models["D_RB_EXT1"] = models["D_RB_EXT1"].copyForMaterialChanges();
	models["D_LF_EXT1"] = models["D_LF_EXT1"].copyForMaterialChanges();
	models["D_LB_EXT1"] = models["D_LB_EXT1"].copyForMaterialChanges();

	models["EXT"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["3GOFRI"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["VODOSTOK_MVM"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));

	models["D_RF_EXT1"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["D_RB_EXT1"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["D_LF_EXT1"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));
	models["D_LB_EXT1"].replaceTexture("81-717.5.png", Resources.idRelative(pathToNewTexture));

	models["D_RF_INT"] = models["D_RF_INT"].copyForMaterialChanges();
	models["D_RB_INT"] = models["D_RB_INT"].copyForMaterialChanges();
	models["D_LF_INT"] = models["D_LF_INT"].copyForMaterialChanges();
	models["D_LB_INT"] = models["D_LB_INT"].copyForMaterialChanges();

	models["INT"] = models["INT"].copyForMaterialChanges();
	models["INTLAMPS2"] = models["INTLAMPS2"].copyForMaterialChanges();
	models["SIDUHI2"] = models["SIDUHI2"].copyForMaterialChanges();

	models["INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["INTLAMPS2"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["SIDUHI2"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));

	models["D_RF_INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["D_RB_INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["D_LF_INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
	models["D_LB_INT"].replaceTexture("81-717.5_int.png", Resources.idRelative(pathToNewTexture2));
}

function uploadPartedModels(rawModels) { 
	result = {};
	for (it = rawModels.entrySet().iterator(); it.hasNext(); ) {
		entry = it.next();

		let jsStringKey = "" + entry.getKey(); // строка в жс строку
		if (jsStringKey.includes("INT") || jsStringKey.includes("LUKI") || jsStringKey == "LAMPI1" || jsStringKey.includes("SIDUHI")) entry.getValue().setAllRenderType("interior"); //включение интерьера
		if (jsStringKey.includes("FARY") || jsStringKey == "BUF" || jsStringKey.includes("INTLAMPS")
		 || jsStringKey == "lsd" || jsStringKey == "lpt" || jsStringKey == "lpt") entry.getValue().setAllRenderType("light"); //включение света

		entry.getValue().applyUVMirror(false, true);
		result[jsStringKey] = ModelManager.uploadVertArrays(entry.getValue());
	}
	return result;
}

function smoothCubic(x) { //кубическая функция - в отрезке 0-1 возвращает сглаженную функцию 0-1
	return x*x*(-2*x + 3);
}